/**
 * \file
 *
 * \version 1.0
 *
 * \brief CRCPʕpyײ
 *
 * \par pLq:
 *		AVR1610: tinyAVR 1nłIEC 60730BKւ̎wj
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Microchip Technology: http://www.microchip.com
 *		http://www.microchip.com/support/ł̎x
 *
 * 쌠 (C) 2017 Microchip Technology. s
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Microchip̖̂͐ɏꂽ̎wȂɂ̿ĳh̑
 *	  i◠(ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳMicrochipAVRiƂ̊֌WłĕzĎgp邱Ƃł
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * MicrochipɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂
 * mɕ܂BƂ̂悤ȑQ̉\iꂽƂ
 * ĂA{gpłȂA܂͎gpȊOŔ(̑AƒfA
 * ܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRARA
 * ʁA܂͕tċN@Ȃ鑹Qɑ΂ĂMicrochipɐӔC
 * Ȃł傤B
 */

#ifndef __CRC_H_HW__
#define __CRC_H_HW__

#include "avr_compiler.h"
#include "classb_crc.h"
#include "avr/io.h"

/**
 * \ingroup classb_crc
 * 
 * \defgroup classb_crc_hw CRCʰ޳
 *
 */

#define CRC_NMI_ENABLED

//! ̗񋓂͑ׯ̗̈ɑ΂鋖e\Ȑݒ܂݂܂B̈̑傫
//! ׯ˭ނŐݒ肳܂Bްė̈͏1߰ވȏłB
enum flash_region {classb_crc_hw_whole_flash_boot_app_code_data = 0x00,
				   classb_crc_hw_boot_app_code_section = 0x02,
				   classb_crc_hw_boot_section = 0x03};

//! \brief ̂߂CRCSCANƗ̈ݒ
//!
//! ̊֐͑ׯ̗̈ݒ肵܂Beׯ̈̑傫޲˭
//! ނŎgpҒ`܂B
//! \note
//!
//! @param set_region	ׯ̈`
static inline void classb_crc_hw_set_flash_regison_to_scan(enum flash_region set_region)
{
	CRCSCAN_CTRLB = set_region;
}

//! \brief CRCJn
//!
//! ̊֐CRCJn܂BSĂ̓ŎgƂł܂B
//! \note
//! CRC_NMI_ENABLED`ꍇACRCSCANꍇISRs
//! ܂BNMIłȂAɏڼ޽ׂꍇAԂߖ񂷂邽߂ISR
//! ͎苎/߉ׂłB
static inline void classb_crc_hw_start(void)
{
#ifdef CRC_NMI_ENABLED
	CRCSCAN_CTRLA = 0x03;
#else
	CRCSCAN_CTRLA = 0x01;
#endif
}

//! \brief CRCZ
//!
//! ̊֐CRCZI𒲂ׂ邽߂ɔwʓŎgƂł܂B
static inline uint8_t crc_busy(void)
{
	return 0x01 & CRCSCAN_STATUS;
}

#endif /* CRC_H_INCLUDED */
